#Область ПрограммныйИнтерфейс

// Читает json файл и преобразует его в объект
//
// Параметры:
//   ПутьКФайлу - Строка - Путь к файлу, который будет прочитан
//   ВСоответствие - Булево - От значения параметра зависит в какой тип будет происходить чтение
//
//  Возвращаемое значение:
//   Соответствие,Структура - Объект из json файла
//
Функция ПрочитатьОбъект(ПутьКФайлу, ВСоответствие = Истина) Экспорт
	ЧтениеJSON = Новый ЧтениеJSON;
	ЧтениеJSON.ОткрытьФайл(ПутьКФайлу, "UTF-8");
	Объект = ПрочитатьJSON(ЧтениеJSON, ВСоответствие);
	ЧтениеJSON.Закрыть();
	Возврат Объект;
КонецФункции

// Записывает произвольный объект в json файл
//
// Параметры:
//   ПутьКФайлу - Строка - Путь  json файлу
//   ОбъектЗаписи - Объект - Объект для серриализации
//
Процедура ЗаписатьОбъект(ПутьКФайлу, ОбъектЗаписи) Экспорт
	ЗаписьJSON = Новый ЗаписьJSON;
	ЗаписьJSON.ОткрытьФайл(ПутьКФайлу, "UTF-8", , Новый ПараметрыЗаписиJSON(, Символы.Таб));
	ЗаписатьJSON(ЗаписьJSON, ОбъектЗаписи);
	ЗаписьJSON.Закрыть();

КонецПроцедуры

// Находит шаблон для отчета 
//
//  Возвращаемое значение:
//   Строка - путь к файлу с шаблоном отчета 
//
Функция РесурсОтчет() Экспорт

	Возврат ОбъединитьПути(Ресурсы(), "report.json");

КонецФункции

// Находит шаблон замечания
//
//  Возвращаемое значение:
//   Строка - Путь к шаблону замечания
//
Функция РесурсЗамечание() Экспорт

	Возврат ОбъединитьПути(Ресурсы(), "diagnostic.json");

КонецФункции

#КонецОбласти

#Область СлужебныйПрограммныйИнтерфейс

// Находит путь к каталогу с ресурсами
//
//  Возвращаемое значение:
//   Строка - путь к каталогу с ресурсами
//
Функция Ресурсы() Экспорт
	
	Возврат ОбъединитьПути(КаталогИсходников(), ДиректорияРесурсов());

КонецФункции

// Находит путь к каталогу исходных файлов программы
//
//  Возвращаемое значение:
//   Строка - Каталог исходных файлов программы
//
Функция КаталогИсходников() Экспорт
 Возврат ОбъединитьПути(ТекущийСценарий().Каталог, "..");
КонецФункции

// Находит путь к корневому каталогу программы
//
//  Возвращаемое значение:
//   Строка - Путь к корневому каталогу программы
//
Функция КаталогПрограммы() Экспорт
	Возврат ОбъединитьПути(КаталогИсходников(), "..");
КонецФункции

// Находит внутренний файл правил
//
//  Возвращаемое значение:
//   Строка - Путь к внутреннему файлу правил
//
Функция ФайлПравилПрограммы() Экспорт
   Возврат ОбъединитьПути(КаталогПрограммы(), "custom-rules.json");
КонецФункции

// Находит внутренний файл правил
//
// Параметры:
//   Путь - Строка - Путь к проекту
//  Возвращаемое значение:
//   Строка - Имя - последняя часть пути
//
Функция ИмяФайлаИлиДиректории(Путь) Экспорт
	Возврат Новый Файл(Путь).ИмяБезРасширения;
КонецФункции

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

Функция ДиректорияРесурсов()
	Возврат "Ресурсы";
КонецФункции

#КонецОбласти
